############################################################################################
# Chatologica - DeleteFile.pm - delete the requested file
# All rights reserved (c) 2000; http://www.chatologica.com/
############################################################################################

package DBPUB1::ADMIN::DeleteFile;

use strict;					# use strict pragma
use DBPUB1::STD::Templater;			# load standard routines related to templates
#use DBPUB1::STD::Common;				# load some standard routines
use vars qw(%P %in %out $MODIFIED);		# declare global variables for this package



sub run						# run the main work for this navigation destination
{
    my($input) = @_;
    *in = $input;				# get script input
    &check_input;
    &show_page;
};



sub check_input
{
    if(!$in{'file'}) {
	$in{'file'} = 'logs/log.txt';
    };
}



sub show_page
{    
    if($in{'file'} !~ m/^(logs|templates)/){	# check for allowed directories
	&DieMsg("You are not allowed to delete <I>'$in{'file'}'</I> file!");
    };
    if(! -e "$in{'file'}") {
	&DieMsg("File <I>'$in{'file'}'</I> does not exist! Maybe it is deleted already.");
    };
    if(unlink($in{'file'})) {
	&DieMsg("File <I>'$in{'file'}'</I> has been deleted successfully!");
    } else {
	&DieMsg("Can't delete file <I>'$in{'file'}'</I>. Check the file permissions!");
    };
};



1; # must return TRUE

