############################################################################################
# Chatologica - Menu.pm - show menu of Admin Panel
# All rights reserved (c) 2000; http://www.chatologica.com/
############################################################################################

package DBPUB1::ADMIN::Menu;

use strict;					# use strict pragma
use DBPUB1::STD::Templater;			# load standard routines related to templates
#use DBPUB1::STD::Common;				# load some standard routines
use vars qw(%P %in %out $MODIFIED);		# declare global variables for this package



sub run						# run the main work for this navigation destination
{
    if((!$MODIFIED) or ($MODIFIED != (stat 'DBPUB1/STD/Parameters.pm')[9])){
	local $^W = 0;					# turn warnings OFF for this block
    	do 'DBPUB1/STD/Parameters.pm';                 	# load Parameters package if changed
    	$MODIFIED = (stat 'DBPUB1/STD/Parameters.pm')[9]; 	# Update the LAST MODIFICATION time
    };
    my($input) = @_;
    *P = &DBPUB1::STD::Parameters::get;		# get script parameters
    *in = $input;				# get script input
    &check_input;				# check script input								
    &prepare_out;				# makes the %out hash
    print "Content-type: text/html\n\n";	# print response header
    print &eval_template(\%out,"templates/admin/$in{'NAVG'}\.htm");	# show the page
};



sub check_input					# check if CGI Input is correct
{
   
};



sub prepare_out					# prepare the output hash %out
{
    %out = ();					# init output - important for mod_perl
    ($out{'script_url'},$out{'nph_script_url'})
        = &get_script_urls(\%P,,'1');         	# get the script names
};



1; # must return TRUE

