############################################################################################
# Chatologica - ShowFile.pm - show the requested file in browser window
# All rights reserved (c) 2000; http://www.chatologica.com/
############################################################################################

package DBPUB1::ADMIN::ShowFile;

use strict;					# use strict pragma
use DBPUB1::STD::Templater;			# load standard routines related to templates
#use DBPUB1::STD::Common;				# load some standard routines
use vars qw(%P %in %out $MODIFIED);		# declare global variables for this package



sub run						# run the main work for this navigation destination
{
    my($input) = @_;
    *in = $input;				# get script input
    &show_page;
};



sub show_page
{    
    if($in{'file'} !~ m{^(logs/|templates/|docs/)}){	# check for allowed directories
	&DieMsg("You are not allowed to read <I>$in{'file'}</I> file!");
    };
    if(! -e "$in{'file'}") {
	&DieMsg("File <I>'$in{'file'}'</I> does not exist!");
    };
    open(F, "<$in{'file'}") || &DieMsg("Can't read <I>'$in{'file'}'</I>: $!"); # open the file to read
    if($in{'file'} =~ m/\.txt$/i) {	# text file is requested to show
	my $is_MSIE = ($ENV{'HTTP_USER_AGENT'} =~ /(MSIE|Internet Explorer)/i); # check browser
	print "Content-type: text/plain\n\n";
	while (defined($_ = <F>)) {
	    if($is_MSIE) {
   	    	$_ =~ s/([^\r]?)\n$/$1\r\n/; # if MS Internet Explorer
	    } else {
		$_ =~ s/\r\n$/\n/;
	    };
   	    print $_;			# send to browser current line
	};	
    } else {				# otherwise show the file as an html page
	print "Content-type: text/html\n\n";
	while (defined($_ = <F>)) {
   	    print $_;			# send to browser current line
	};	
    };
    print "\r\n";
    close F;
};



1; # must return TRUE


