############################################################################################
# Chatologica - ShowTemplate.pm - show a template page
# All rights reserved (c) 2000; http://www.chatologica.com/
############################################################################################

package DBPUB1::ADMIN::ShowTemplate;

use strict;					# use strict pragma
use DBPUB1::STD::Templater;			# load standard routines related to templates
#use DBPUB1::STD::Common;			# load some standard routines
use vars qw(%P %in %out $MODIFIED);		# declare global variables for this package



sub run						# run the main work for this navigation destination
{
    my($input) = @_;
    *in = $input;				# get script input
    &check_input;				# check script input								
    &prepare_out;				# makes the %out hash
    print "Content-type: text/html\n\n";	# print response header
    print &eval_template(\%out,"templates/admin/$in{'file'}");	# show the page
};



sub check_input					# check if CGI Input is correct
{
    if(!$in{'file'}) { &DieMsg("Please pass variable <i>file=the_template_file</i>!");};
    if(! -e "templates/admin/$in{'file'}") {
	&DieMsg("File <i>'templates/admin/$in{'file'}'</i> does not exist");
    };
};



sub prepare_out					# prepare the output hash %out
{
    %out = ();					# init output - important for mod_perl
    ($out{'script_url'},$out{'nph_script_url'})
        = &get_script_urls(\%P,'1');           	# get the script names
};



1; # must return TRUE

