############################################################################################
# Chatologica - Templates.pm - edit template files
# All rights reserved (c) 2000; http://www.chatologica.com/
############################################################################################

package DBPUB1::ADMIN::Templates;

use strict;					# use strict pragma
use DBPUB1::STD::Templater;			# load standard routines related to templates
use DBPUB1::STD::Common;				# load some standard routines
use DBPUB1::STD::FileTools;			# load file related routines
use vars qw(%P %in %out $MODIFIED);		# declare global variables for this package



sub run						# run the main work for this navigation destination
{
    if((!$MODIFIED) or ($MODIFIED != (stat 'DBPUB1/STD/Parameters.pm')[9])){
	local $^W = 0;					# turn warnings OFF for this block
    	do 'DBPUB1/STD/Parameters.pm';                 	# load Parameters package if changed
    	$MODIFIED = (stat 'DBPUB1/STD/Parameters.pm')[9]; 	# Update the LAST MODIFICATION time
    };
    my($input) = @_;
    *P = &DBPUB1::STD::Parameters::get;		# get script parameters
    *in = $input;				# get script input
    &check_input;				# check script input
    if(!$in{'show'}) {								
    	&prepare_out;				# makes the %out hash
    	print "Content-type: text/html\n\n";	# print response header
    	print &eval_template(\%out,"templates/admin/$in{'NAVG'}\.htm");# show the page
    } else {
	use DBPUB1::ADMIN::ShowFile;
	$in{'file'} = "templates/$in{'file'}";
	&DBPUB1::ADMIN::ShowFile::run(\%in);
    };
};



sub check_input					# check if CGI Input is correct
{
   
};



sub prepare_out					# prepare the output hash %out
{
    %out = ();					# init output - important for mod_perl
    ($out{'script_url'},$out{'nph_script_url'})
        = &get_script_urls(\%P,'1');           	# get the script names
    my ($file) = ();
    if($in{'save'}) {				# button 'Save as' pushed
	if(!$in{'save_as'}) {
	    &DieMsg("Please, enter name of the file you wish to save!");
	};
	$in{'content'} =~ s/(?!\\)(.)\@/$1\\\@/sg;	# checking for uncommented $ and @ signs
	$in{'content'} =~ s/(?!\\)(.)\$(?!(out|ENV){)/$1\\\$/sg;
	open(F,">templates/$in{'save_as'}") || &DieMsg("Can't save file <i>'templates/$in{'save_as'}'</I>: $!");
	$in{'content'} =~ s/\r\n/\n/sg;
	print F $in{'content'};			# save the file
	close F;
	$out{'file'} = &to_HTML($in{'save_as'});
	$out{'content'} = &to_HTML($in{'content'});
	$out{'response'} = "File 'templates/$out{'file'}' saved successfully.<P>";

    } elsif ($in{'delete'}) {			# button 'Delete it' pushed
	if(!$in{'file'}) {
	    &DieMsg("Please, select which file to delete!");
	};
	$file = &to_HTML($in{'file'});
	unlink("templates/$in{'file'}") || &DieMsg("Can't delete file <i>'templates/$file'</I>: $! Probably it is deleted already or the file permissions are not set properly.");
	$out{'response'} = "File 'templates/$file' deleted successfully.<P>";

    } elsif ($in{'view'}) {			# button 'View' pushed
	if(!$in{'file'}) {
	    &DieMsg("Please, select which file to view!");
	};
	$out{'file'} = &to_HTML($in{'file'});
	open(F,"<templates/$in{'file'}") || &DieMsg("Can't read file <i>'templates/$out{'file'}'</I>: $!");
	my @content = <F>; chomp @content;
	$out{'content'} = &to_HTML(join("\n",@content));
    };
    my(@list) = (&dir('templates','reqursive'));	# list templates directory
    my $filename = '';
    foreach (sort @list) {
	$filename = &to_HTML($_);	# make the current file selected in the list:
	if($out{'file'} && ($filename eq $out{'file'})) {
	    $out{'files'} .= "<option SELECTED>$filename\n";	# the current file hit
	} else {
	    $out{'files'} .= "<option>$filename\n";		# do not select other files
	};
    };
};



1; # must return TRUE

