#########################################################################################
# Chatologica - FileTools.pm - reading file and directories tools
# All rights reserved (c) 2000; http://www.chatologica.com/
#########################################################################################

package DBPUB1::STD::FileTools;

use strict;				# use strict pragma
use IO::File;				# use file handler methods
use DBPUB1::STD::Templater;           	# load standard routines related to templates


sub dir
{
    my($path,$reqursive) = @_;		# $path to the directory and $reqursive option
    my(@files,$file) = ();
    my($D) = new IO::File;		# new file handler
    opendir($D,"$path") || &DieMsg("Can't read <I>'$path'</I> directory: $!"); # open directory
    while($file = readdir($D)) {
	if($file !~ m/^\./) {		# do not list hidden files
	    chomp $file;
	    if ($reqursive && -d "$path/$file") {	# do reqursive
	 	push @files,map {$_ = "$file/$_";} (&dir("$path/$file",$reqursive));
            } else {
	    	push @files, $file;
	    };
	};
    };
    closedir $D;
    return @files;		# return list of files
}



sub import {			# this function is called automatically by use Module; statement
    my $pkg = shift;
    my $callpkg = caller(0);	# import these symbols into the caller package:
    no strict 'refs';
    foreach $_ (qw(dir)) {
    	*{"${callpkg}::$_"} = \&{"${pkg}::$_"};
    };
}



1; # must return TRUE

