#########################################################################################
# Chatologica - Templater.pm - define how to use html templates and print messages
# All rights reserved (c) 2000; http://www.chatologica.com/
#########################################################################################

package DBPUB1::STD::Templater;

use strict;				# use strict pragma
use vars qw(%out);			# put %out into symbol table



sub eval_template			# evaluate a template putting real values of %out inside
{
    my($output,$file,$template_as_string) = @_;
    *out = $output;				# %out will be the hash with output information
    $out{'random'} = 1 + (int rand(100));	# generate a random number used for for banner rotation as LE
    if(!defined($template_as_string)) {
        $template_as_string = '';                       # init template value
        if(open(F,"<$file")) {                          # open and read the template file
            my @template = <F>;
            close F;                                    # Show the template:
            $template_as_string = join('',@template);
        };
    };
    local $^W = 0;				# disable warnings
    my $template = eval("no strict \"vars\"; return <<\"endofhtml\";\n$template_as_string\nendofhtml\n");
    use strict;
    local $^W = 1;				# turn warnings on again
    if($@) {					# template error occured
	print ("<B>ERROR IN TEMPLATE: $file</B> $@ Probably missing closing } in definition of element of hash %out: \$out{'..... in your template.");
	return '';
    };
    if($file =~ /footer\.htm$/) {
        $template .= <<"endofhtml";
        <P><CENTER><SMALL><I>powered by</I> <a href="http://www.chatologica.com/"
        target="_top">Chatologica</a></SMALL></CENTER><P>
endofhtml
    };
    return $template;
};



sub DieMsg 			# prints a custom message as a web page and exits
{
    my($message,$tmpl_language) = @_;	# $tmpl_language - which language is the message
    my(%out) = ();
    $out{'message'} = $message;	# set the message as output variable
    print "Content-type: text/html\n\n";	# print response header
    if($tmpl_language) {	# have to use custom designed template to show nicely
    	print &eval_template(\%out,"templates/$tmpl_language/notice.htm");
    } else {
        print "<BODY BGCOLOR=\"#ffffff\">$message";       # show just plain message without decoration
    };
    if($ENV{'FCGI_ROLE'} || '') {
	FCGI->flush;   		# if we run under Fast CGI exit the connection - not the app.
	FCGI->finish;
    } else {
	exit;			# normal exit
    };
};



sub get_script_urls		# return this script URL
{
    my($P, $admin) = @_;
    my($script_url, $nph_script_url, $script_name) = ();
    $script_name = $ENV{'SCRIPT_NAME'} || '';
    if(!$script_name) {
        if($0 =~ m{[/\\]([^/\\]*)$}) {
            $script_name = $1;
        } else {
            $script_name = $0;
        };
    };
    if((!defined $admin) && $$P{'script_url'}) {       # script url provided explicitly as parameter
	$script_url = $$P{'script_url'};
    } else {
        $script_url = $script_name;
    };
    if($ENV{'FCGI_ROLE'} || '') {	# Fast CGI does not support nph-scripts
	$nph_script_url = $script_url;	# so use the same url as the current one
    } else {
        if((!defined $admin) && $$P{'nph_script_url'}) {# nph-script url provided explicitly as parameter
	    $nph_script_url = $$P{'nph_script_url'};
    	} else {
            $nph_script_url = $script_name;
            $nph_script_url =~ s{/(?!nph-)([^/]*)$}{/nph-$1};           # URI provided
            $nph_script_url =~ s{^(?!nph-)([^/]*)$}{nph-$1};            # only the script name provided
	};
    };
    return ($script_url, $nph_script_url);
}



sub import {			# this function is called automatically by use Module; statement
    my $pkg = shift;
    my $callpkg = caller(0);	# import these symbols into the caller package:
    no strict 'refs';
    foreach $_ (qw(DieMsg eval_template get_script_urls)) {
    	*{"${callpkg}::$_"} = \&{"${pkg}::$_"};
    };
}



1; # must return TRUE

