#!/usr/bin/perl
############################################################################################
# Change the first line of this file if teh path to your perl version 5 is not /usr/bin/perl
# Example: #!/usr/local/bin/perl
# To set Perl warnings On use -w switch -> Example: #!/usr/bin/perl -w
############################################################################################
# Chatologica - cgi script wrapper
# Author: Daniel Dinev; All rights reserved (c) 2000; http://www.chatologica.com/
############################################################################################

use strict;				# use strict pragma: makes Perl more strict to code
$| = 1;					# do not buffer the script output
use vars qw($have_to_chdir);		# define globally this flag
BEGIN {
    # Now making the current working directory to be the directory where this script resides.
    # This is needed usually if the web server is IIS on Windows NT platform.
    my $path = $0;			# $0 is the full path to this script
    if($path =~ s{[/\\][^/\\]+$}{}) {	# remove script filename from the path
	chdir($path) || 		# move to the directory of this file or print error msg.
	print "Content-type: text/html\n\nCan't navigate to '$path' directory: $!";
    };
    chdir '../' || print "Content-type: text/html\n\nCan't chdir '../'";
    $have_to_chdir = 0;
};

if($have_to_chdir) {			# chdir because BEGIN {} is undefined
    my $path = $0;			# $0 is the full path to this script
    if($path =~ s{[/\\][^/\\]+$}{}) {	# remove script filename from the path
	chdir($path) || 		# move to the directory of this file or print error msg.
	print "Content-type: text/html\n\nCan't navigate to '$path' directory: $!";
    };
    chdir '../' || print "Content-type: text/html\n\nCan't chdir '../'";
};
$have_to_chdir = 1;			# because of mod_perl (we have to chdir on every request)
use DBPUB1::STD::MyCarp; 		# makes error messages appear on the browser window
use DBPUB1::STD::CGI_Parser; 		# load a standard light-weight cgi input handler

my $in = &DBPUB1::STD::CGI_Parser::GetInput; # get the CGI Input and return reference to hash
$$in{'NAVG'} = $$in{'NAVG'} || '';	# to avoid CGI warnings	
if($$in{'NAVG'} =~ m/^\s*$/) {  	# destination unknown -> set default
    $$in{'NAVG'} = 'Main';		# use the default Main.pm navigation object
};
eval("use DBPUB1::ADMIN::$$in{'NAVG'};");	# Now load the requested navigation module which is
					# a .pm file somewhere under your NAVG directory.
eval("&DBPUB1::ADMIN::$$in{'NAVG'}::run(\$in);");  # Execute its run() method to do the main work
						# for this request

#print "<P>CPU: " . times;  		# uncomment to show at the bottom of page
					# the CPU usage for this script


				