#!/usr/bin/perl
############################################################################################
# Change the first line of this file if teh path to your perl version 5 is not /usr/bin/perl
# Example: #!/usr/local/bin/perl
# To set Perl warnings On use -w switch -> Example: #!/usr/bin/perl -w
############################################################################################
# Chatologica - the main Fast CGI script wrapper
# Author: Daniel Dinev; All rights reserved (c) 2000; http://www.chatologica.com/
############################################################################################

use strict;				# use strict pragma: makes Perl more strict to code
$| = 1;					# do not buffer the script output
BEGIN {
    # Now making the current working directory to be the directory where this script resides.
    # This is needed usually if the web server is IIS on Windows NT platform.
    my $path = $0;			# $0 is the full path to this script
    if($path =~ s{[/\\][^/\\]+$}{}) {	# remove script filename from the path
	chdir($path) || 		# Move to the directory of this file or print error msg.
	print "Content-type: text/html\n\nCan't navigate to '$path' directory: $!";
    };
};
use DBPUB1::STD::MyCarp; 		# makes error messages appear on the browser window
umask 0000;				# do not mask file permissions
use DBPUB1::STD::CGI_Parser; 		# load a standard light-weight cgi input handler
use FCGI;				# load Fast CGI module
$SIG{__WARN__} = \&DBPUB1::STD::MyCarp::CgiDie; 	# set die and warn handlers again because FCGI
$SIG{__DIE__} = \&DBPUB1::STD::MyCarp::CgiDie;	# overrides them

my $count = 0;						# init counter for processed http requests
while ((FCGI::accept >= 0) && ($count < 10000)) {	# wait for a request
    $SIG{__WARN__} = \&DBPUB1::STD::MyCarp::CgiDie;	# set die and warn handlers again because of FCGI
    $SIG{__DIE__} = \&DBPUB1::STD::MyCarp::CgiDie;
    my $in = &DBPUB1::STD::CGI_Parser::GetInput; # get the CGI Input and return reference to hash
    $$in{'NAVG'} = $$in{'NAVG'} || '';	# to avoid CGI warnings	
    if($$in{'NAVG'} =~ m/^\s*$/) {  	# destination unknown -> set default
    	$$in{'NAVG'} = 'Main';		# use the default Main.pm navigation object
    };
    eval("use DBPUB1::NAVG::$$in{'NAVG'};");	# Now load the requested navigation module which is
						# a .pm file somewhere under your NAVG directory.
    eval("&DBPUB1::NAVG::$$in{'NAVG'}::run(\$in);");  	# Execute its run() method to do the main work
							# for this request
    $count++;
    #print $count;			# uncomment to see the number of processed requests till now
    #print "<P>CPU: " . times;  	# uncomment to show at the bottom of page
					# the CPU usage for this application till now
};

# This Fast CGI application exits after a certain number of processed requests.
# Default life length is 10 000 requests.


				